diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/__init__.py b/web/pgadmin/browser/server_groups/servers/pgagent/__init__.py
index 81d9c7d5..2b908776 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/__init__.py
@@ -130,7 +130,7 @@ class JobView(PGChildNodeView):
     operations = dict({
         'obj': [
             {'get': 'properties', 'delete': 'delete', 'put': 'update'},
-            {'get': 'properties', 'post': 'create'}
+            {'get': 'properties', 'post': 'create', 'delete': 'delete'}
         ],
         'nodes': [{'get': 'nodes'}, {'get': 'nodes'}],
         'sql': [{'get': 'sql'}],
@@ -368,17 +368,25 @@ SELECT EXISTS(
         )
 
     @check_precondition
-    def delete(self, gid, sid, jid):
+    def delete(self, gid, sid, jid=None):
         """Delete the pgAgent Job."""
 
-        status, res = self.conn.execute_void(
-            render_template(
-                "/".join([self.template_path, 'delete.sql']),
-                jid=jid, conn=self.conn
+        if jid is None:
+            data = request.form if request.form else json.loads(
+                request.data, encoding='utf-8'
             )
-        )
-        if not status:
-            return internal_server_error(errormsg=res)
+        else:
+            data = {'ids': [jid]}
+
+        for jid in data['ids']:
+            status, res = self.conn.execute_void(
+                render_template(
+                    "/".join([self.template_path, 'delete.sql']),
+                    jid=jid, conn=self.conn
+                )
+            )
+            if not status:
+                return internal_server_error(errormsg=res)
 
         return make_json_response(success=1)
 
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js b/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
index 44a6b5c1..ba6f219d 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
@@ -12,6 +12,8 @@ define('pgadmin.node.pga_job', [
         type: 'coll-pga_job',
         columns: ['jobid', 'jobname', 'jobenabled', 'jlgstatus', 'jobnextrun', 'joblastrun', 'jobdesc'],
         hasStatistics: false,
+        canDrop: true,
+        canDropCascade: false,
       });
   }
 
diff --git a/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py b/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
index 8a531a84..7b6b3127 100644
--- a/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
@@ -184,7 +184,7 @@ class ResourceGroupView(NodeView):
     operations = dict({
         'obj': [
             {'get': 'properties', 'delete': 'delete', 'put': 'update'},
-            {'get': 'list', 'post': 'create'}
+            {'get': 'list', 'post': 'create', 'delete': 'delete'}
         ],
         'nodes': [{'get': 'node'}, {'get': 'nodes'}],
         'sql': [{'get': 'sql'}],
@@ -497,7 +497,7 @@ class ResourceGroupView(NodeView):
             return internal_server_error(errormsg=str(e))
 
     @check_precondition
-    def delete(self, gid, sid, rg_id):
+    def delete(self, gid, sid, rg_id=None):
         """
         This function will drop the resource group object
 
@@ -506,44 +506,48 @@ class ResourceGroupView(NodeView):
             sid: Server ID
             rg_id: Resource Group ID
         """
-        try:
-            # Get name for resource group from rg_id
-            sql = render_template(
-                "/".join([self.template_path, 'delete.sql']),
-                rgid=rg_id, conn=self.conn
+        if rg_id is None:
+            data = request.form if request.form else json.loads(
+                request.data, encoding='utf-8'
             )
-            status, rgname = self.conn.execute_scalar(sql)
-            if not status:
-                return internal_server_error(errormsg=rgname)
+        else:
+            data = {'ids': [rg_id]}
 
-            if rgname is None:
-                return make_json_response(
-                    success=0,
-                    errormsg=gettext(
-                        'Error: Object not found.'
-                    ),
-                    info=gettext(
-                        'The specified resource group could not be found.\n'
-                    )
+        try:
+            for rg_id in data['ids']:
+                # Get name for resource group from rg_id
+                sql = render_template(
+                    "/".join([self.template_path, 'delete.sql']),
+                    rgid=rg_id, conn=self.conn
                 )
+                status, rgname = self.conn.execute_scalar(sql)
+                if not status:
+                    return internal_server_error(errormsg=rgname)
+
+                if rgname is None:
+                    return make_json_response(
+                        success=0,
+                        errormsg=gettext(
+                            'Error: Object not found.'
+                        ),
+                        info=gettext(
+                            'The specified resource group '
+                            'could not be found.\n'
+                        )
+                    )
 
-            # drop resource group
-            sql = render_template(
-                "/".join([self.template_path, 'delete.sql']),
-                rgname=rgname, conn=self.conn
-            )
-            status, res = self.conn.execute_scalar(sql)
-            if not status:
-                return internal_server_error(errormsg=res)
+                # drop resource group
+                sql = render_template(
+                    "/".join([self.template_path, 'delete.sql']),
+                    rgname=rgname, conn=self.conn
+                )
+                status, res = self.conn.execute_scalar(sql)
+                if not status:
+                    return internal_server_error(errormsg=res)
 
             return make_json_response(
                 success=1,
-                info=gettext("Resource Group dropped"),
-                data={
-                    'id': rg_id,
-                    'sid': sid,
-                    'gid': gid,
-                }
+                info=gettext("Resource Group dropped")
             )
 
         except Exception as e:
diff --git a/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js b/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
index 4eac6e78..ac545cad 100644
--- a/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
+++ b/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
@@ -11,6 +11,8 @@ define('pgadmin.node.resource_group', [
         label: gettext('Resource Groups'),
         type: 'coll-resource_group',
         columns: ['name', 'cpu_rate_limit', 'dirty_rate_limit'],
+        canDrop: true,
+        canDropCascade: false,
       });
   }
 
@@ -63,7 +65,9 @@ define('pgadmin.node.resource_group', [
 
       // Defining model for resource group node
       model: pgBrowser.Node.Model.extend({
+        idAttribute: 'oid',
         defaults: {
+          oid: undefined,
           name: undefined,
           cpu_rate_limit: 0.0,
           dirty_rate_limit: 0.0,
@@ -71,6 +75,9 @@ define('pgadmin.node.resource_group', [
 
         // Defining schema for the resource group node
         schema: [{
+          id: 'oid', label: gettext('OID'), type: 'text',
+          editable: false, disabled: true, mode:['properties'],
+        },{
           id: 'name', label: gettext('Name'), cell: 'string',
           type: 'text',
         },{
diff --git a/web/pgadmin/browser/server_groups/servers/resource_groups/tests/test_resource_groups_delete_multiple.py b/web/pgadmin/browser/server_groups/servers/resource_groups/tests/test_resource_groups_delete_multiple.py
new file mode 100644
index 00000000..ddc93374
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/resource_groups/tests/test_resource_groups_delete_multiple.py
@@ -0,0 +1,84 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+import json
+
+from pgadmin.utils import server_utils as server_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as resource_groups_utils
+
+
+class ResourceGroupsDeleteTestCase(BaseTestGenerator):
+    """This class will delete the resource groups"""
+    scenarios = [
+        ('Delete multiple resource groups',
+         dict(url='/browser/resource_group/obj/'))
+    ]
+
+    def setUp(self):
+        self.server_id = parent_node_dict["server"][-1]["server_id"]
+        server_response = server_utils.connect_server(self, self.server_id)
+        if not server_response["info"] == "Server connected.":
+            raise Exception("Could not connect to server to add resource "
+                            "groups.")
+        if "type" in server_response["data"]:
+            if server_response["data"]["type"] == "pg":
+                message = "Resource groups are not supported by PG."
+                self.skipTest(message)
+            else:
+                if server_response["data"]["version"] < 90400:
+                    message = "Resource groups are not supported by PPAS " \
+                              "9.3 and below."
+                    self.skipTest(message)
+        self.resource_groups = ["test_resource_group_delete%s" %
+                                str(uuid.uuid4())[1:8],
+                                "test_resource_group_delete%s" %
+                                str(uuid.uuid4())[1:8]]
+        self.resource_group_ids = [
+            resource_groups_utils.create_resource_groups(
+                self.server, self.resource_groups[0]),
+            resource_groups_utils.create_resource_groups(
+                self.server, self.resource_groups[1])]
+
+    def runTest(self):
+        """This function will delete resource groups."""
+        resource_grp_response = resource_groups_utils.verify_resource_group(
+            self.server, self.resource_groups[0])
+        if not resource_grp_response:
+            raise Exception("Could not find the resource group to fetch.")
+
+        resource_grp_response = resource_groups_utils.verify_resource_group(
+            self.server, self.resource_groups[1])
+        if not resource_grp_response:
+            raise Exception("Could not find the resource group to fetch.")
+
+        data = {'ids': self.resource_group_ids}
+        response = self.tester.delete(
+            "{0}{1}/{2}/".format(self.url,
+                                 utils.SERVER_GROUP,
+                                 self.server_id),
+            follow_redirects=True,
+            data=json.dumps(data),
+            content_type='html/json'
+        )
+        self.assertEquals(response.status_code, 200)
+
+    def tearDown(self):
+        """This function delete the resource group from the database."""
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'],
+                                             self.server['sslmode'])
+        resource_groups_utils.delete_resource_group(connection,
+                                                    self.resource_group)
diff --git a/web/pgadmin/browser/server_groups/servers/roles/__init__.py b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
index 63d1bf7f..c977d0ee 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
@@ -100,7 +100,7 @@ class RoleView(PGChildNodeView):
     operations = dict({
         'obj': [
             {'get': 'properties', 'delete': 'drop', 'put': 'update'},
-            {'get': 'list', 'post': 'create'}
+            {'get': 'list', 'post': 'create', 'delete': 'drop'}
         ],
         'nodes': [{'get': 'node'}, {'get': 'nodes'}],
         'sql': [{'get': 'sql'}],
@@ -494,8 +494,10 @@ rolmembership:{
                 forbidden_msg = None
 
                 if action in ['drop', 'update']:
-                    check_permission = True
-                    fetch_name = True
+                    if 'rid' in kwargs:
+                        fetch_name = True
+                        check_permission = True
+
                     if action == 'drop':
                         forbidden_msg = _(
                             "The current user does not have permission to drop"
@@ -696,15 +698,47 @@ rolmembership:{
         )
 
     @check_precondition(action='drop')
-    def drop(self, gid, sid, rid):
+    def drop(self, gid, sid, rid=None):
 
-        status, res = self.conn.execute_2darray(
-            u"DROP ROLE {0};".format(self.qtIdent(self.conn, self.role))
-        )
-        if not status:
-            return internal_server_error(
-                _("Could not drop the role.\n{0}").format(res)
+        if rid is None:
+            data = request.form if request.form else json.loads(
+                request.data, encoding='utf-8'
             )
+        else:
+            data = {'ids': [rid]}
+
+        for rid in data['ids']:
+            status, res = self.conn.execute_dict(
+                render_template(
+                    self.sql_path + 'permission.sql',
+                    rid=rid,
+                    conn=self.conn
+                )
+            )
+
+            if not status:
+                return internal_server_error(
+                    _(
+                        "Error retrieving the role information.\n{0}"
+                    ).format(res)
+                )
+
+            if len(res['rows']) == 0:
+                return gone(
+                    _("Could not find the role on the database "
+                      "server.")
+                )
+
+            row = res['rows'][0]
+
+            status, res = self.conn.execute_2darray(
+                u"DROP ROLE {0};".format(self.qtIdent(self.conn,
+                                                      row['rolname']))
+            )
+            if not status:
+                return internal_server_error(
+                    _("Could not drop the role.\n{0}").format(res)
+                )
 
         return success_return()
 
diff --git a/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js b/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
index 09f0f4e2..419ae45f 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
+++ b/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
@@ -15,6 +15,8 @@ define('pgadmin.node.role', [
           'rolsuper', 'rolcreaterole', 'rolcreatedb', 'rolcatupdate',
           'rolinherit', 'rolreplication',
         ],
+        canDrop: true,
+        canDropCascade: false,
       });
   }
 
diff --git a/web/pgadmin/browser/server_groups/servers/roles/tests/test_role_delete_multiple.py b/web/pgadmin/browser/server_groups/servers/roles/tests/test_role_delete_multiple.py
new file mode 100644
index 00000000..77bc7f71
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/roles/tests/test_role_delete_multiple.py
@@ -0,0 +1,56 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+import json
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as roles_utils
+
+
+class LoginRoleDeleteTestCase(BaseTestGenerator):
+    """This class has delete role scenario"""
+    scenarios = [
+        # Fetching default URL for roles node.
+        ('Delete Multiple Roles', dict(url='/browser/role/obj/'))
+    ]
+
+    def setUp(self):
+        self.server_id = parent_node_dict["server"][-1]["server_id"]
+        self.role_names = [
+            "role_delete_%s" % str(uuid.uuid4())[1:8],
+            "role_delete_%s" % str(uuid.uuid4())[1:8]
+        ]
+        self.role_ids = [
+            roles_utils.create_role(self.server, self.role_names[0]),
+            roles_utils.create_role(self.server, self.role_names[1])
+        ]
+
+    def runTest(self):
+        """This function test the delete role scenario"""
+        data = {'ids': self.role_ids}
+        response = self.tester.delete(
+            self.url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id) + '/',
+            data=json.dumps(data),
+            content_type='html/json',
+            follow_redirects=True)
+        self.assertEquals(response.status_code, 200)
+
+    def tearDown(self):
+        """This function delete the role from added server"""
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'],
+                                             self.server['sslmode'])
+        roles_utils.delete_role(connection, self.role_names)
diff --git a/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py b/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
index 2b8eaeef..eed396cd 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
@@ -150,7 +150,7 @@ def write_role_id(response_data):
     db_output.close()
 
 
-def delete_role(connection, role_name):
+def delete_role(connection, role_names):
     """
     This function use to delete the existing roles in the servers
 
@@ -160,18 +160,23 @@ def delete_role(connection, role_name):
     :type role_name: str
     :return: None
     """
+    if not isinstance(role_names, list):
+        role_names = [role_names]
+
     try:
-        pg_cursor = connection.cursor()
-        pg_cursor.execute(
-            "SELECT * FROM pg_catalog.pg_roles WHERE rolname='%s'" % role_name)
-        role_count = pg_cursor.fetchone()
-        if role_count:
-            old_isolation_level = connection.isolation_level
-            connection.set_isolation_level(0)
+        for role_name in role_names:
             pg_cursor = connection.cursor()
-            pg_cursor.execute("DROP ROLE %s" % role_name)
-            connection.set_isolation_level(old_isolation_level)
-            connection.commit()
+            pg_cursor.execute(
+                "SELECT * FROM pg_catalog.pg_roles WHERE rolname='%s'" %
+                role_name)
+            role_count = pg_cursor.fetchone()
+            if role_count:
+                old_isolation_level = connection.isolation_level
+                connection.set_isolation_level(0)
+                pg_cursor = connection.cursor()
+                pg_cursor.execute("DROP ROLE %s" % role_name)
+                connection.set_isolation_level(old_isolation_level)
+                connection.commit()
         connection.close()
     except Exception as exception:
         exception = "Error while deleting role: %s: line:%s %s" % (
diff --git a/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py b/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
index c54ffa93..d8a64e43 100644
--- a/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
@@ -80,7 +80,7 @@ class TablespaceView(PGChildNodeView):
     operations = dict({
         'obj': [
             {'get': 'properties', 'delete': 'delete', 'put': 'update'},
-            {'get': 'list', 'post': 'create'}
+            {'get': 'list', 'post': 'create', 'delete': 'delete'}
         ],
         'nodes': [{'get': 'node'}, {'get': 'nodes'}],
         'children': [{'get': 'children'}],
@@ -395,51 +395,54 @@ class TablespaceView(PGChildNodeView):
             return internal_server_error(errormsg=str(e))
 
     @check_precondition
-    def delete(self, gid, sid, tsid):
+    def delete(self, gid, sid, tsid=None):
         """
         This function will drop the tablespace object
         """
-        try:
-            # Get name for tablespace from tsid
-            status, rset = self.conn.execute_dict(
-                render_template(
-                    "/".join([self.template_path, 'nodes.sql']),
-                    tsid=tsid, conn=self.conn
-                )
+        if tsid is None:
+            data = request.form if request.form else json.loads(
+                request.data, encoding='utf-8'
             )
+        else:
+            data = {'ids': [tsid]}
 
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            if not rset['rows']:
-                return make_json_response(
-                    success=0,
-                    errormsg=gettext(
-                        'Error: Object not found.'
-                    ),
-                    info=gettext(
-                        'The specified tablespace could not be found.\n'
+        try:
+            for tsid in data['ids']:
+                # Get name for tablespace from tsid
+                status, rset = self.conn.execute_dict(
+                    render_template(
+                        "/".join([self.template_path, 'nodes.sql']),
+                        tsid=tsid, conn=self.conn
                     )
                 )
 
-            # drop tablespace
-            SQL = render_template(
-                "/".join([self.template_path, 'delete.sql']),
-                tsname=(rset['rows'][0])['name'], conn=self.conn
-            )
+                if not status:
+                    return internal_server_error(errormsg=rset)
+
+                if not rset['rows']:
+                    return make_json_response(
+                        success=0,
+                        errormsg=gettext(
+                            'Error: Object not found.'
+                        ),
+                        info=gettext(
+                            'The specified tablespace could not be found.\n'
+                        )
+                    )
 
-            status, res = self.conn.execute_scalar(SQL)
-            if not status:
-                return internal_server_error(errormsg=res)
+                # drop tablespace
+                SQL = render_template(
+                    "/".join([self.template_path, 'delete.sql']),
+                    tsname=(rset['rows'][0])['name'], conn=self.conn
+                )
+
+                status, res = self.conn.execute_scalar(SQL)
+                if not status:
+                    return internal_server_error(errormsg=res)
 
             return make_json_response(
                 success=1,
-                info=gettext("Tablespace dropped"),
-                data={
-                    'id': tsid,
-                    'sid': sid,
-                    'gid': gid,
-                }
+                info=gettext("Tablespace dropped")
             )
 
         except Exception as e:
diff --git a/web/pgadmin/browser/server_groups/servers/tablespaces/static/js/tablespace.js b/web/pgadmin/browser/server_groups/servers/tablespaces/static/js/tablespace.js
index 90e97f0a..c5df5d70 100644
--- a/web/pgadmin/browser/server_groups/servers/tablespaces/static/js/tablespace.js
+++ b/web/pgadmin/browser/server_groups/servers/tablespaces/static/js/tablespace.js
@@ -16,6 +16,8 @@ define('pgadmin.node.tablespace', [
         columns: ['name', 'spcuser', 'description'],
         hasStatistics: true,
         statsPrettifyFields: ['Size'],
+        canDrop: true,
+        canDropCascade: false,
       });
   }
 
@@ -303,6 +305,7 @@ define('pgadmin.node.tablespace', [
         },
       },
       model: pgBrowser.Node.Model.extend({
+        idAttribute: 'oid',
         defaults: {
           name: undefined,
           owner: undefined,
diff --git a/web/pgadmin/browser/server_groups/servers/tablespaces/tests/utils.py b/web/pgadmin/browser/server_groups/servers/tablespaces/tests/utils.py
index bee1d91f..2bb8aa1f 100644
--- a/web/pgadmin/browser/server_groups/servers/tablespaces/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/tablespaces/tests/utils.py
@@ -44,7 +44,7 @@ def get_tablespace_data(tablespace_path, db_owner):
     return data
 
 
-def create_tablespace(server, test_tablespace_name):
+def create_tablespace(server, test_tablespace_name, test_tablespace_dir=None):
     try:
         connection = utils.get_db_connection(server['db'],
                                              server['username'],
@@ -55,8 +55,10 @@ def create_tablespace(server, test_tablespace_name):
         old_isolation_level = connection.isolation_level
         connection.set_isolation_level(0)
         pg_cursor = connection.cursor()
+        if test_tablespace_dir is None:
+            test_tablespace_dir = server['tablespace_path']
         pg_cursor.execute("CREATE TABLESPACE %s LOCATION '%s'" %
-                          (test_tablespace_name, server['tablespace_path']))
+                          (test_tablespace_name, test_tablespace_dir))
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
 
